package nl.maartenvr98.PluginTemplate;

import nl.maartenvr98.PluginKit.KitSetup;
import nl.maartenvr98.PluginKit.PluginKit;
import nl.maartenvr98.PluginKit.log.Log;
import nl.maartenvr98.PluginTemplate.commands.MyCommand;
import nl.maartenvr98.PluginTemplate.config.MainConfig;
import nl.maartenvr98.PluginTemplate.listeners.PlayerListener;
import org.bukkit.plugin.java.JavaPlugin;

public final class Main extends JavaPlugin {

    @Override
    public void onEnable() {
        PluginKit.setPlugin(this);
        Log.success("Enabling PluginTemplate");

        // Setup plugin with PluginKit
        KitSetup.init()
                // Commands
                .addCommand("template", new MyCommand())

                // Listeners
                .addListener(new PlayerListener())

                // Configs
                .addConfig(new MainConfig())

                // Tasks
                // .addTask(new MyCustomTask())

                // Hooks
                // .addHook("Vault", new Vault())

                // Migrations
                // .addMigration(new CreatePlayersMigration());

                // Settings
                .withSettings(settings -> {
                     // Define your settings here

                     // settings.setMessagesConfig("messages");
                 })

                // Start plugin
                .start();

        Log.success("PluginTemplate is enabled");
    }

    @Override
    public void onDisable() {
        Log.success("Disabling PluginTemplate");

        // Disable plugin
        PluginKit.disablePlugin();

        Log.success("PluginTemplate is disabled");
    }

    /**
     * Get plugin instance
     *
     * @return JavaPlugin instance
     */
    public static JavaPlugin getInstance() {
        return PluginKit.getInstance();
    }

}
